#include <condefs.h>
#pragma hdrstop
#pragma argsused
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <stdlib.h>
#include <winsock.h>
#include <fcntl.h>
#include <io.h>

   int configReadFtp(char *configfile, int port,
                    char *ip, char *lip,
                    char *user, char *pass,
                    char *dir, char *ldir,
                    char *files, int *nrfiles) {
   // Functia de citire a configuratiei clientului ftp.
   // Citirea se face din fisierul specificat de configfile
   // Intoarce 0 la configurare reusita sau -1 la esec
      int i;
      FILE *fConf;
      char temp[255], *p, *q, *r;
      if ((fConf=fopen(configfile, "r"))==NULL)
         return (-1); // Codul -1 = eroare la citirea fisierului de configurare
      for ( (*nrfiles)=0, r=files; ; ) {
         p = fgets(temp, 255, fConf); // Citeste o linie din fisierul de configurare
         if (p == NULL)
            break; // terminat citirea fisierului
         for( q=p+strlen(p)-1; ((*q)<=' ')&&(q-p>0); q--);
         *(q+1) = '\0'; // Ignora sfarsit de linie
         if (strlen(p) <=2)
            continue; // Ignorarea liniilor scurte
         if (p[0] == '#')
            continue; // Ignorarea liniilor comentariu
         if ((q = strstr(p, "=")) == NULL) {
            strcpy(r, temp); // Copiaza nume fisier de transferat
            r += strlen(r) + 1; // la fisierul urmator
            (*nrfiles)++;
            continue;
         } //Linie nume de fisier
         q++;
         for (i=0; i<q-p; i++)
            p[i] = tolower(p[i]); // transformat nume in litere mici
         if (strstr(p, "localip=") != NULL) {
            for (i=0; i<strlen(q); i++)
               if (q[i] == '.')
                  q[i] = ','; //IP local +port
            strcpy(lip, q);    // au octetii separati
            strcat(lip, ",");  // prin virgula
            itoa(port/256, temp, 10);
            strcat(lip, temp);
            strcat(lip, ",");
            itoa(port%256, temp, 10);
            strcat(lip, temp);
            continue;
         } //IPlocal
         if (strstr(p, "serverip=") != NULL) {
            strcpy(ip, q); // Copiaza IP server
            continue;
         } //IPserver
         if (strstr(p, "user=") != NULL) {
            strcpy(user, q); // Copiaza user
            continue;
         } //user
         if (strstr(p, "password=") != NULL) {
            strcpy(pass, q); // Copiaza parola
            continue;
         } //password
         if (strstr(p, "remotedir=") != NULL) {
            strcpy(dir, q); // Copiaza director la distanta
            continue;
         } //remotedir
         if (strstr(p, "localdir=") != NULL) {
            strcpy(ldir, q); // Copiaza director local
            continue;
         } //localdir
      }//for
      fclose(fConf);
      return(0); // terminarea normala a fixarii configuratiei
   }//configReadFtp

   int authFtp(struct sockaddr_in *saddr, char *ip, char *user, char *pass) {
   // Functia de autenticicare a unui client FTP.
   // Deschide conexiunea de control si autentifica ip, user si parola.
   // Intoarce >0 (descriptorul socket) la succes sau <0 la esec/
      int sock;
      char mesaj[1024];
   
   // creare socket
      sock = socket(AF_INET,SOCK_STREAM,0);
      if (sock < 0)
         return (-1); // Eroare la creare socket
      memset((char *)saddr, 0, sizeof(struct sockaddr));
      saddr->sin_family=AF_INET;
      saddr->sin_addr.s_addr=inet_addr(ip);
      saddr->sin_port=htons(21);
   
   // conectarea la server
      if(connect (sock, (struct sockaddr*)saddr, sizeof(struct sockaddr_in)) < 0)
         return (-2); // Eroare la connect
   
   //preluare mesaj initial server
      if (recv(sock, mesaj, 1024, 0) <= 3)
         return (-3); // eroare rcv mesaj initial
      if (strstr(mesaj, "220") != mesaj)
         return(-4); // Trebuie sa raspunda 220 - awaiting input
   
   //Trimitere nume de user la server si asteptare raspuns
      strcpy(mesaj,"user ");
      strcat(mesaj, user);
      strcat (mesaj,"\n");
      if (send(sock, mesaj, strlen(mesaj), 0) != strlen(mesaj))
         return (-5); // transmitere eronata user
      if (recv(sock, mesaj, 1024, 0) <= 3)
         return (-6); // eroare raspuns user
      if (strstr(mesaj, "331") != mesaj)
         return(-7); // Trebuie sa raspunda 331 - User OK
   
   //Trimitere parola la server si asteptare raspuns
      strcpy(mesaj,"pass ");
      strcat(mesaj, pass);
      strcat (mesaj,"\n");
      if (send(sock, mesaj, strlen(mesaj), 0) != strlen(mesaj))
         return (-8); // transmitere eronata parola
      if (recv(sock, mesaj, 1024, 0) <= 3)
         return (-9); // eroare raspuns parola
      if (strstr(mesaj, "230") != mesaj)
         return(-10); // Trebuie sa raspunda 230 - User login
   
   // Intoarce socketul de control
      return (sock);
   } //authFtp

   int setContextFtp(int sock, char *type, char *dir) {
   //Functia de fixare a contextului FTP: tipul transferului:
   // ascii sau binar (type)
   // directorul curent de pe serverul ftp (dir)
   // Intoarce 0 la context fixat sau <0 la esec.
      char mesaj[1024];
   
   //Trimite comanda TYPE si asteapta confirmarea
      strcpy(mesaj,"TYPE ");
      strcat(mesaj, type);
      strcat(mesaj, "\n");
      if (send(sock, mesaj, strlen(mesaj), 0) != strlen(mesaj))
         return (-11); // transmitere eronata type
      if (recv(sock, mesaj, 1024, 0) <= 3)
         return (-12); // eroare raspuns type
      if (strstr(mesaj, "200") != mesaj)
         return(-13); // Trebuie sa raspunda 200 - Command Ok
   
   //Trimite comanda CWD si asteapta confirmarea
      strcpy(mesaj,"CWD ");
      strcat(mesaj, dir);
      strcat(mesaj,"\n");
      if (send(sock, mesaj, strlen(mesaj), 0) != strlen(mesaj))
         return (-14); // transmitere eronata director curent
      if (recv(sock, mesaj, 1024, 0) <= 3)
         return (-15); // eroare raspuns cwd
      if (strstr(mesaj, "250") != mesaj)
         return(-16); // Trebuie sa raspunda 250 - Requested file action Ok
   
      return (0); // context fixat
   }//setContextFTP

   int putAsciiFtp(int sockc, char *ldir, int port, char *files, int nrfiles) {
   //Deschidere conexiunea de date. Socketul asculta pe masina locala pe
   // portul port. La el se va conecta serverul de FTP pentru a realiza
   // transferul efectiv al fisierelor.
   // Intoarce 0 la derulare normala,
   // <0 la erori de conexiune sau 
   // >0 (al catelea fisier este in transfer) la erori de transfer fisiere .
   
   // Aceasta functie este conceputa pentru a face put de fisiere text (ASCII),
   // deci fisierele locale sunt tratate cu: fopen, fgets, fputs, fclose.
   // Pentru a face operatii get in loc de put, se va transmite RETR in loc de STOR.
   // Pentru schimburi (get, put) in mod binar, se vor folosi functiile:
   // open, read, write, close.
   
      char mesaj[1024], *r;
      struct sockaddr_in sockd; // Socket de asteptare a transferului de date
      struct sockaddr_in socke; // Socket pe care ftp trimite date
      int socketd, sockete, fd, lung, i;
      FILE *ft;
   
      socketd = socket(AF_INET, SOCK_STREAM, 0);
      if (socketd < 0)
         return(-20); // eroare la deschidere socket de date
      memset((char *)&sockd, 0, sizeof(sockd));
      sockd.sin_family = AF_INET;
      sockd.sin_addr.s_addr = htonl(INADDR_ANY);
      sockd.sin_port = htons(port);
   
   // rezervarea portului in kernel
      if( bind(socketd,(struct sockaddr *) &sockd, sizeof(sockd)) <0)
         return (-21); //Eroare la  bind
      if (listen(socketd, 2) < 0)
         return (-22); // Eroare la listen
   
   //Se trimit continuturile fisierelor
      for (i=0, r=files; i<nrfiles; i++, r+=strlen(r)+1) {
         // Pentru fiecare fisier specificat in fisierul de configurare
         // se creeaza o conexiune inversa pentru transmiterea fisierelor
      
         // Trimite comanda PORT si asteapta raspunsul
         strcpy(mesaj,"port ");
         strcat(mesaj, ldir);
         strcat(mesaj,"\n");
         if (send(sockc, mesaj, strlen(mesaj), 0) != strlen(mesaj))
            return (-23); // transmitere eronata port
         if (recv(sockc, mesaj, 1024, 0) <= 3)
            return (-24); // eroare raspuns port
         if (strstr(mesaj, "200") != mesaj)
            return(-25); // Trebuie sa raspunda 200 - Command Ok
      
        // Trimite comanda STOR si asteapta raspunsul
         strcpy(mesaj,"stor ");
         strcat(mesaj, r);
         strcat(mesaj,"\n");
         if (send(sockc, mesaj, strlen(mesaj), 0) != strlen(mesaj))
            return (-26); // transmitere eronata stor
         if (recv(sockc, mesaj, 1024, 0) <= 3)
            return (-27); // eroare raspuns stor
         if (strstr(mesaj, "150") != mesaj)
            return(-28); // Trebuie sa raspunda 150 - Open ascii connection
      
         // Exista conexiune, trimite un fisier
         lung = sizeof(socke);
         fd=accept(socketd,(struct sockaddr *) &socke, &lung);
         if (fd < 0)
            return (-30); // eroare la accept
         if ((ft = fopen(r, "r")) == NULL)
            return (-31); // eroare la deschiderea fisierului
      
      	// Bucla de trimitere a continutului fisierului
         for ( ;fgets(mesaj, 1024, ft) != NULL; )
            if (send(fd, mesaj, strlen(mesaj), 0) != strlen(mesaj))
               return (i+1); // eroare la transmiterea celui de-al i-lea fisier
         fclose(ft);
         close(fd);
         shutdown(fd,2);
      
      	// Raspunsul de la transmiterea unui fisier
         if (recv(sockc, mesaj, 1024, 0) <= 3)
            return (-33); // eroare raspuns transmitere fisier
      }//end for
   
      close(socketd);
      return (0); // terminare normala
   }//putFTP

   int main(int argc, char* argv[]) {
   // Plecand de la fisierul de configurare CONFIG_FILE se transfera o
   // serie de fisiere ASCII de la client la un server de FTP
   
   // Macrou pentru erori
   #define ERR(S,N) {fprintf(stderr,"\n%d ",N);perror(S);exit(abs(N));}
   // Constante
   #define PORT 1234
   #define CONFIG_FILE ".\\config.ftp"
   
      int socketc, nrFile;
      struct sockaddr_in sockc; // Socket de conexiune (la port 21)
      char IP[1024], LIP[1024], USER[1024], PASS[1024],
         DIR[1024], LDIR[1024], argFile[50*255];
   
      WORD wVersiune;
      WSADATA wDate;
      int wEroare, i;
      char *r;
   
      if ((i = configReadFtp(CONFIG_FILE, PORT, IP, LIP, USER, PASS, DIR, LDIR,
                            argFile, &nrFile)) < 0)
         ERR("Eroare la citirea fisierului de configurare", i);
   
      wVersiune = MAKEWORD((1),(1));
      wEroare = WSAStartup(wVersiune, &wDate);
      if (wEroare!=0)
         ERR("Winsock not supported..\n", wEroare);
   
      if ((socketc = authFtp(&sockc, IP, USER, PASS)) < 0)
         ERR("Eroare de autentificare FTP", socketc);
   
      if ((i = setContextFtp(socketc, "A", DIR)) < 0)
         ERR("Eroare la stabilire context FTP", i);
   
      if ((i = putAsciiFtp(socketc, LIP, PORT, argFile, nrFile)) != 0)
         ERR("Eroare la transferurile de fisiere", i);
   
      close(socketc);
      printf("S-au transferat pe server fisierele:\n");
      for (i=0, r=argFile; i<nrFile; i++, r+=strlen(r)+1 )
         printf("%s\n", r);
      printf("Pentru continuare tastati <ENTER>. Pentru intrerupere <CTRL/C>");
      gets(IP);
      return 0;
   }//main()

